#!/usr/bin/perl -w

use strict;

use lib '[path]';

my $count = 0;

my $scriptParam = $ARGV[0];

my $iterations  = $ARGV[1];

while ($count<$iterations){

  my $epoch = time;
  my ($sec, $min, $hour, $day,$month,$year) = (localtime($epoch))[0,1,2,3,4,5];

  my $service 		= "$scriptParam";
  my $detected 		= sprintf("%04s-%02s-%02sT%02s:%02s:%02s\n",($year+1900),($month+1),$day,$hour,$min,$sec);
  my $type 		= "bruteforce";
  my $source_type 	= "IP";
  my $source 		= "1.2.3.4";
  my $target_proto 	= "TCP";
  my $target_port 	= "123";
  my $attack_scale 	= "123";
  my $note 		= "$scriptParam $count";
  my $priority 		= "null";
  my $timeout 		= "123";

  my @event 		= ($service, $detected, $type, $source_type, $source, $target_proto, $target_port, $attack_scale, $note, $priority, $timeout);

#-------------------------------------------------------------------------------
# Use of warden-client sender.
# This code should developer add to his/her detection application
# (with corresponding paths appropriately changed).

# Path to warden-client folder
  my $warden_path = '[path]';

# Inclusion of warden-client sender module
  require $warden_path . '/lib/WardenClientSend.pm';

# Sending event to Warden server
  WardenClientSend::saveNewEvent($warden_path, \@event);
  print time . " $scriptParam $count\n";
  $count++;
}
exit 0;
