<?

/*
        DefaultFormRenderer
        Author: B. Dailey
        Website: www.dailytechnology.net
        Free to be used, modified, & distributed so long as this text remains.
*/
require_once "HTML/QuickForm/Renderer/Default.php";

class DefaultFormRenderer {
    // HTML Quick Form
    var $Form;
    var $FormRenderer;
    var $FormTemplate;
    var $ElementTemplate;
    var $HeaderTemplate;
    var $RequiredNoteTemplate;

    /**
    * Form constructor.
    */
    function __construct(& $Form) {
            $this->Form = & $Form;

            $this->setDefaultFormTemplate();
            $this->setDefaultElementTemplate();
            $this->setDefaultHeaderTemplate();
            $this->setDefaultRequiredNoteTemplate();

            $this->FormRenderer = & new HTML_QuickForm_Renderer_Default;
            $this->FormRenderer->setFormTemplate($this->FormTemplate);
            $this->FormRenderer->setElementTemplate($this->ElementTemplate);
            $this->FormRenderer->setHeaderTemplate($this->HeaderTemplate);
            $this->FormRenderer->setRequiredNoteTemplate($this->RequiredNoteTemplate);
    }

    function setDefaultFormTemplate() {
            $this->FormTemplate= <<<HTML
            <div class="long_form">
                    <ul>
                            <form{attributes}>
                                    {content}
                            </form>
                    </ul>
            </div>
HTML;
    }

    function setDefaultElementTemplate() {
            $this->ElementTemplate = <<<HTML

                    <li class="formli">
			    <div>	
					    <label>
		                                    {label}
		                                    <!-- BEGIN required --><span class="required">*</span><!-- END required -->
					    </label>
	                                    {element}
	                                    <!-- BEGIN error -->
	                                    <span class="error">{error}</span>
	                                    <!-- END error -->
			    </div>
                    </li>
HTML;
    }

    function setDefaultHeaderTemplate() {
            $this->HeaderTemplate = <<<HTML
                    <h2>{header}</h2>
HTML;
    }

    function setDefaultRequiredNoteTemplate() {
            $this->RequiredNoteTemplate = <<<HTML
                    <li><div id="requirednote clear"><span class="required">*</span> Denotes required field.</div></li>
HTML;
    }

    function display() {
            $this->Form->accept($this->FormRenderer);
            echo $this->FormRenderer->toHTML();
    }

}

