use Data::Dumper;
use JSON;

# Prevod IP na long podobu
sub ip2long
{
        my($ip) = @_;

        my @octets = split(/\./, $ip);
        my $DEC = ($octets[0] * 1 << 24) + ($octets[1] * 1 << 16) + ($octets[2] * 1 << 8) + ($octets[3]);

        $DEC = ($DEC > 0 ? $DEC : $DEC + (2 ** 32));

        return $DEC;
}

# Ziskani prvni a posledni adresy v long podobe
sub getFirstLastLong
{
    my($cidr) = @_;

    my @adds;

    #rozdeleni CIDR formatu na IP a masku
    my @items = split('/', $cidr);
    #Prevod podsite na long format
    my $is = ip2long($items[0]);
    push @adds, $is;

    #Prevedeni posledni IP v podsiti na long
    my $ib = $is + (2 ** (32 - $items[1]) - 1);
    push @adds, $ib;

    return @adds;
}

#orezani
sub trim
{
    my($string) = @_;

    $$string =~ s/^\s+//;
    $$string =~ s/\s+$//;
}

#http://en.wikipedia.org/wiki/Reserved_IP_addresses
$input = "
route: 0.0.0.0/8
descr: broadcast
route: 10.0.0.0/8
descr: local10
route: 100.64.0.0/10
descr: RFC6598
route: 127.0.0.0/8
descr: loopback
route: 169.254.0.0/16
descr: autoconfiguration
route: 172.16.0.0/12
descr: local172
route: 192.0.2.0/24
descr: RFC5737
route: 192.88.99.0/24
descr: 6to4anycast
route: 192.168.0.0/16
descr: local192
route: 198.18.0.0/15
descr: RFC2544
route: 198.51.100.0/24
descr: RFC5737
route: 203.0.113.0/24
descr: RFC5737
route: 224.0.0.0/4
descr: multicast
route: 240.0.0.0/4
descr: future
route: 255.255.255.255/32
descr: limitedbroadcast
";


@winfo = split("\n", $input);
#print Dumper(@winfo);

#todo zbytek co neni ve whois separatne

%data=();
$route="";
foreach(@winfo) {
	if($_ =~ /route:\s+(.*)/) {
		$route = $1;
		$data{$route}{'route'} = $route;
	}
	if($_ =~ /descr:\s+(.*)/) {
		$data{$route}{'descr'} = $1;
	}
}

my $sql_net_cond = "";
foreach (keys %data)
{
    my $net = $_;
    trim(\$net);

    my @adds = getFirstLastLong($net);
    $data{$net}{'first'} = $adds[0];
    $data{$net}{'last'} = $adds[1];

    #Testovaci vypis
    #printf("%s\t %u - %u\n", $net, $adds[0], $adds[1]);
#    $sql_net_cond .= "inet_aton(ip) BETWEEN $adds[0] AND $adds[1] OR ";
}
#print $sql_net_cond;

print encode_json(\%data);

#$sql_net_cond = substr($sql_net_cond, 0, -3);
